﻿/*
Copyright (c) 2010, Jason DiOrio
 * Modified by Mark Scappini (enabling session state)
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this 
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation 
  and/or other materials provided with the distribution.

* Neither the name of Extensible Development Solutions Group (ExtenDev) nor the
  names of its contributors may be used to endorse or promote products derived 
  from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Reflection;
using System.Web;
using System.Web.Handlers;
using System.Web.SessionState;
using ExtenDev.Web.Extensions;

namespace ExtenDev.Web.Extensions
{
    public class ControlMethodModule : ControlMethodImpl, IHttpModule
    {

        public ControlMethodModule()
        {
        }

        #region IHttpModule and IDisposable Implementation

        ~ControlMethodModule()
        {
            Dispose(false);
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {

        }

        void IHttpModule.Init(HttpApplication application)
        {
            OnInit(application);
        }

        protected virtual void OnInit(HttpApplication application)
        {
            application.PostMapRequestHandler += new EventHandler(PostMapRequestHandler);
            application.PostAcquireRequestState += new EventHandler(this.PostAcquireRequestState);
        }

        #endregion

        #region Control Methods Implementation

        protected virtual void PostMapRequestHandler(object sender, EventArgs e)
        {
            HttpApplication application = (HttpApplication)sender;
            ApplySessionRequestHandler(application);
        }

        protected virtual void PostAcquireRequestState(object sender, EventArgs eventArgs)
        {
            HttpApplication application = (HttpApplication)sender;
            ProcessRestRequest(application);
        }

        #endregion
    }
}